## espresso 6.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
# CMake < 3.13 cannot install external targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2152

# CMake < 3.14 generates incorrect dependency graphs with
# alias targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2521

# Policy CMP0048: The project() command manages VERSION variables
set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)

project(qe
    VERSION 6.6.0
    DESCRIPTION "ESPRESSO: opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization"
    LANGUAGES Fortran C)

if(${qe_BINARY_DIR} STREQUAL ${qe_SOURCE_DIR})
  message(FATAL_ERROR "QE source folder cannot be safely used as a build folder!")
endif()

# CMake < v3.18 cannot discover the ARM Performance Library
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*|ARM64.*)")
    if(CMAKE_VERSION VERSION_LESS 3.18.0)
        message("-- CMake versions less then 3.18 cannot automatically discover the ARM Performance Library!")
    endif()
endif()

######################################################################
# Define the paths for static libraries and executables
######################################################################
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/lib CACHE PATH "Single output directory for building all libraries.")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables.")
set(QE_TESTS_DIR ${qe_BINARY_DIR}/tests/bin)


###########################################################
# Build helpers
###########################################################
set(PROJECT_CMAKE ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include(cmake/qeHelpers.cmake)

###########################################################
# Build Type
# Ensure that a specific, default build type is set when
# none has been explicitly set by the user
###########################################################
qe_ensure_build_type("Release")

###########################################################
# Modules
###########################################################
include(CheckFunctionExists)
# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

###########################################################
# Build Options
###########################################################
option(QE_ENABLE_TEST
    "enable unit tests" ON)
option(QE_ENABLE_MPI
    "enable distributed execution support via MPI" ON)
option(QE_ENABLE_OPENMP
    "enable distributed execution support via OpenMP" OFF)
option(QE_ENABLE_TRACE
    "enable execution tracing output" OFF)
option(QE_ENABLE_MPI_INPLACE
    "enable inplace MPI calls (ignored when QE_ENABLE_MPI=OFF)" OFF)
option(QE_ENABLE_MPI_MODULE
    "use MPI via Fortran module instead of mpif.h header inclusion" OFF)
option(QE_ENABLE_BARRIER
    "enable global synchronization between execution units" OFF)
option(QE_LAPACK_INTERNAL
    "enable internal reference LAPACK" OFF)
option(QE_ENABLE_SCALAPACK
    "enable SCALAPACK execution units" OFF)
option(QE_ENABLE_ELPA
    "enable ELPA execution units" OFF)
option(QE_ENABLE_HDF5
    "enable HDF5 data collection" OFF)
option(QE_ENABLE_CUDA
    "enable CUDA acceleration on NVIDIA GPUs" OFF)
option(QE_ENABLE_DOC
    "enable documentation building" OFF)
set(QE_FFTW_VENDOR "AUTO" CACHE 
    STRING "select a specific FFTW library [Intel_DFTI, Intel_FFTW3, ArmPL, IBMESSL, FFTW3, Internal]")

# TODO change all ifdefs throughout code base to match
# cmake options
# TODO symbols beginning with '__' followed by a capital
# character are reserved for standard library use (at
# least in C, not sure about Fortran), change all feature
# macros to avoid weird behaviors

# Disable all configuration headers used to be generated
# by configure (see <qe>/include/)
qe_add_global_compile_definitions(QE_NO_CONFIG_H)

if(QE_ENABLE_TRACE)
    qe_add_global_compile_definitions(__TRACE)
endif()
if(QE_ENABLE_MPI_INPLACE)
    qe_add_global_compile_definitions(__USE_INPLACE_MPI)
endif()
if(QE_ENABLE_MPI_MODULE)
    qe_add_global_compile_definitions(__MPI_MODULE)
endif()
if(QE_ENABLE_BARRIER)
    qe_add_global_compile_definitions(__USE_BARRIER)
endif()
if(QE_ENABLE_MPI)
    # OMPI_SKIP_MPICXX: skip CXX APIs on openmpi, cause trouble to C APIs
    qe_add_global_compile_definitions(__MPI OMPI_SKIP_MPICXX)
endif()
if(QE_ENABLE_SCALAPACK)
    qe_add_global_compile_definitions(__SCALAPACK)
endif()
if(QE_ENABLE_HDF5)
    qe_add_global_compile_definitions(__HDF5)
endif()

# Feature checks
check_function_exists(mallinfo HAVE_MALLINFO)
if(HAVE_MALLINFO)
    qe_add_global_compile_definitions(HAVE_MALLINFO)
endif()

# Check options consistency
if(QE_ENABLE_ELPA AND NOT QE_ENABLE_SCALAPACK)
    message(FATAL_ERROR "ELPA requires SCALAPACK support, enable it with '-DQE_ENABLE_SCALAPACK=ON' or disable ELPA with '-DQE_ENABLE_ELPA=OFF'")
endif()
if(QE_ENABLE_SCALAPACK AND NOT QE_ENABLE_MPI)
    message(FATAL_ERROR "SCALAPACK requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable SCALAPACK with '-DQE_ENABLE_SCALAPACK=OFF'")
endif()
# if(QE_ENABLE_HDF5 AND NOT QE_ENABLE_MPI)
#    message(FATAL_ERROR "HDF5 requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable HDF5 with '-DQE_ENABLE_HDF5=OFF'")
# endif()


###########################################################
# language standard requirements
###########################################################
# TODO need to require all compilers using the same one
if(CMAKE_C_COMPILER_ID MATCHES "PGI")
  set(CMAKE_C_STANDARD 11)
  set(CMAKE_C_STANDARD_REQUIRED ON)
  set(CMAKE_C_EXTENSIONS OFF)
endif()

############################################################
## Compiler vendor specific options
############################################################
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
    include(${PROJECT_CMAKE}/GNUFortranCompiler.cmake)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
    include(${PROJECT_CMAKE}/NVFortranCompiler.cmake)
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "XL")
    include(${PROJECT_CMAKE}/IBMFortranCompiler.cmake)
endif()

###########################################################
# OpenMP
# The following targets will be defined:
add_library(qe_openmp_fortran INTERFACE)
add_library(QE::OpenMP_Fortran ALIAS qe_openmp_fortran)
add_library(qe_openmp_c INTERFACE)
add_library(QE::OpenMP_C ALIAS qe_openmp_c)
qe_install_targets(qe_openmp_fortran qe_openmp_c)
###########################################################
if(QE_ENABLE_OPENMP)
    find_package(OpenMP REQUIRED Fortran C)
    target_link_libraries(qe_openmp_fortran
        INTERFACE OpenMP::OpenMP_Fortran)
    target_link_libraries(qe_openmp_c
        INTERFACE OpenMP::OpenMP_C)
endif(QE_ENABLE_OPENMP)

###########################################################
# MPI
# The following targets will be defined:
add_library(qe_mpi_fortran INTERFACE)
add_library(QE::MPI_Fortran ALIAS qe_mpi_fortran)
qe_install_targets(qe_mpi_fortran)
###########################################################
if(QE_ENABLE_MPI)
    find_package(MPI REQUIRED Fortran)
    target_link_libraries(qe_mpi_fortran
        INTERFACE MPI::MPI_Fortran)
endif(QE_ENABLE_MPI)

###########################################################
# Lapack
# The following targets will be defined:
add_library(qe_lapack INTERFACE)
add_library(QE::LAPACK ALIAS qe_lapack)
qe_install_targets(qe_lapack)
#######################################################################
if(NOT QE_LAPACK_INTERNAL)
    if(NOT BLA_VENDOR)
        if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64.*")
            message(STATUS "Trying to find LAPACK from Intel MKL")
            if(QE_ENABLE_OPENMP)
                SET(BLA_VENDOR Intel10_64lp)
            else()
                SET(BLA_VENDOR Intel10_64lp_seq)
            endif()
            find_package(LAPACK)
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "i686.*|i386.*|x86.*")
            message(STATUS "Trying to find LAPACK from Intel MKL - 32bit")
            SET(BLA_VENDOR Intel10_32)
            find_package(LAPACK)
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*|ARM64.*)")
            message(STATUS "Trying to find LAPACK from ARM Performance Library")
            if(QE_ENABLE_OPENMP)
                SET(BLA_VENDOR Arm_mp)
            else()
                SET(BLA_VENDOR Arm)
            endif()
            find_package(LAPACK)
        endif()
        if(NOT LAPACK_FOUND)
            message(STATUS "Trying to find alternative LAPACK libraries")
            SET(BLA_VENDOR All)
            find_package(LAPACK)
        endif()
    else()
        find_package(LAPACK)
    endif()
    if(LAPACK_FOUND)
        list(APPEND _lapack_libs
            ${BLAS_LIBRARIES}
            ${BLAS_LINKER_FLAGS}
            ${LAPACK_LIBRARIES}
            ${LAPACK_LINKER_FLAGS})
        list(REMOVE_DUPLICATES "${_lapack_libs}")
        message(STATUS "Found LAPACK: ${_lapack_libs}")
        target_link_libraries(qe_lapack INTERFACE ${_lapack_libs})
    else()
        message(FATAL_ERROR "Failed to find a complete set of external BLAS/LAPACK library by FindLAPACK. "
                            "Variables controlling FindLAPACK can be found at CMake online documentation. "
                            "Alternatively, '-DQE_LAPACK_INTERNAL=ON' may be used to enable reference LAPACK "
                            "at a performance loss compared to optimized libraries.")
    endif()
else()
    message(WARNING "Internal reference LAPACK is enabled! It is less performant than vendor optimized libraries.")
    if(CMAKE_Fortran_COMPILER_ID MATCHES "XL")
        message(FATAL_ERROR "IBM XL compilers cannot build internal LAPACK with QE "
                            "due to the conflict in flags for free vs fixed format. "
                            "Please use an optimized LAPACK or build internal reference LAPACK separately.")
    endif()
    message(STATUS "Installing QE::LAPACK via submodule")
    qe_git_submodule_update(external/lapack)
    add_subdirectory(external/lapack EXCLUDE_FROM_ALL)
    target_link_libraries(qe_lapack INTERFACE lapack)
    qe_fix_fortran_modules(lapack)
    qe_install_targets(lapack)
endif()

###########################################################
# SCALAPACK
# The following targets will be defined:
add_library(qe_scalapack INTERFACE)
add_library(QE::SCALAPACK ALIAS qe_scalapack)
qe_install_targets(qe_scalapack)
###########################################################
if(QE_ENABLE_SCALAPACK)
    find_package(SCALAPACK REQUIRED QUIET)
    message(STATUS "Found SCALAPACK: ${SCALAPACK_LIBRARIES};${SCALAPACK_LINKER_FLAGS}")
    target_link_libraries(qe_scalapack
        INTERFACE
            ${SCALAPACK_LIBRARIES}
            ${SCALAPACK_LINKER_FLAGS})
endif(QE_ENABLE_SCALAPACK)

###########################################################
# ELPA
# The following targets will be defined:
add_library(qe_elpa INTERFACE)
add_library(QE::ELPA ALIAS qe_elpa)
qe_install_targets(qe_elpa)
###########################################################
if(QE_ENABLE_ELPA)
    find_package(ELPA REQUIRED)

    # Check if ELPA version is compatible with QE
    if(ELPA_VERSION_STRING VERSION_GREATER_EQUAL "2018.11")
        set(QE_ELPA_DEFINITIONS __ELPA)
    elseif(ELPA_VERSION_STRING VERSION_GREATER_EQUAL "2016.11")
        set(QE_ELPA_DEFINITIONS __ELPA_2016)
    elseif(ELPA_VERSION_STRING VERSION_GREATER_EQUAL "2015")
        set(QE_ELPA_DEFINITIONS __ELPA_2015)
    else()
        message(FATAL_ERROR "ELPA verion ${ELPA_VERSION_STRING} is not supported.")
    endif()
    message(STATUS "Add ELPA flag : ${QE_ELPA_DEFINITIONS}")
    qe_add_global_compile_definitions(${QE_ELPA_DEFINITIONS})

    # Looking for module directory

=== Makefile ===
# Copyright (C) 2001-2020 Quantum ESPRESSO Foundation
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include make.inc

# execute a target irrespective of the presence of a file or directory 
# with the same name
.PHONY: install

default :
	@echo 'to install Quantum ESPRESSO, type at the shell prompt:'
	@echo '  ./configure [--prefix=]'
	@echo '  make [-j] target'
	@echo ' '
	@echo 'where target identifies one or multiple CORE PACKAGES:'
	@echo '  pw           basic code for scf, structure optimization, MD'
	@echo '  ph           phonon code, Gamma-only and third-order derivatives'
	@echo '  hp           calculation of the Hubbard parameters from DFPT'
	@echo '  pwcond       ballistic conductance'
	@echo '  neb          code for Nudged Elastic Band method'
	@echo '  pp           postprocessing programs'
	@echo '  pwall        same as "make pw ph pp pwcond neb"'
	@echo '  cp           CP code: Car-Parrinello molecular dynamics'
	@echo '  tddfpt       time dependent dft code'
	@echo '  gwl          GW with Lanczos chains'
	@echo '  ld1          utilities for pseudopotential generation'
	@echo '  xspectra     X-ray core-hole spectroscopy calculations'
	@echo '  couple       Library interface for coupling to external codes'
	@echo '  epw          Electron-Phonon Coupling with wannier functions'
	@echo '  gui          Graphical User Interface'
	@echo '  all          same as "make pwall cp ld1 tddfpt hp"'
	@echo ' '
	@echo 'where target identifies one or multiple THIRD-PARTIES PACKAGES:'
	@echo '  gipaw        NMR and EPR spectra'
	@echo '  w90          Maximally localised Wannier Functions'
	@echo '  want         Quantum Transport with Wannier functions'
	@echo '  yambo        electronic excitations with plane waves'
	@echo '  d3q          general third-order code and thermal transport codes'
	@echo ' '
	@echo 'where target is one of the following suite operation:'
	@echo '  doc          build documentation'
	@echo '  links        create links to all executables in bin/'
	@echo '  tar          create a tarball of the source tree'
	@if test -d GUI/; then \
		echo '  tar-gui      create a standalone PWgui tarball from the GUI sources'; \
		echo '  tar-qe-modes create a tarball for QE-modes (Emacs major modes for Quantum ESPRESSO)'; fi
	@echo '  clean        remove executables and objects'
	@echo '  veryclean    remove files produced by "configure" as well'
	@echo '  distclean    revert distribution to the original status'

###########################################################
# Main targets
###########################################################

# The syntax "( cd PW ; $(MAKE) TLDEPS= all || exit 1)" below
# guarantees that error code 1 is returned in case of error and make stops
# If "|| exit 1" is not present, the error code from make in subdirectories
# is not returned and make goes on even if compilation has failed

pw : pwlibs
	if test -d PW ; then \
	( cd PW ; $(MAKE) TLDEPS= all || exit 1) ; fi

cp : bindir libs mods
	if test -d CPV ; then \
	( cd CPV ; $(MAKE) TLDEPS= all || exit 1) ; fi

ph : phlibs
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) TLDEPS= all || exit 1) ; fi

hp : hplibs
	if test -d HP; then \
	( cd HP; $(MAKE) TLDEPS= all || exit 1) ; fi

neb : pwlibs
	if test -d NEB; then \
	( cd NEB; $(MAKE) TLDEPS= all || exit 1) ; fi

tddfpt : lrmods
	if test -d TDDFPT; then \
	( cd TDDFPT; $(MAKE) TLDEPS= all || exit 1) ; fi

pp : pwlibs
	if test -d PP ; then \
	( cd PP ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

pwcond : pwlibs
	if test -d PWCOND ; then \
	( cd PWCOND ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

acfdt : phlibs
	if test -d ACFDT ; then \
	( cd ACFDT ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gwl : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

gipaw : pwlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

d3q : phlibs
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

ld1 : bindir libs mods
	if test -d atomic ; then \
	( cd atomic ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

xspectra : pwlibs
	if test -d XSpectra ; then \
	( cd XSpectra ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

couple : pw cp
	if test -d COUPLE ; then \
	( cd COUPLE ; $(MAKE) TLDEPS= all || exit 1 ) ; fi

epw: phlibs
	if test -d EPW ; then \
	( cd EPW ; $(MAKE) all || exit 1; \
		cd ../bin; ln -fs ../EPW/bin/epw.x . ); fi

travis : pwall epw
	if test -d test-suite ; then \
	( cd test-suite ; make run-travis || exit 1 ) ; fi

gui :
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= init; \
	    echo ; \
	    echo "  PWgui has been built in ./GUI/PWgui/. You may try it either as:  "; \
	    echo "         ./GUI/PWgui/pwgui" ; \
	    echo "     or"; \
	    echo "         cd ./GUI/PWgui";\
	    echo "         ./pwgui" ; \
	    echo ; \
	else \
	    echo ; \
	    echo "  Sorry, gui works only for git sources !!!" ; \
	    echo ; \
	fi

pwall : pw neb ph pp pwcond acfdt

all   : pwall cp ld1 tddfpt hp xspectra gwl 

###########################################################
# Auxiliary targets used by main targets:
# compile modules, libraries, directory for binaries, etc
###########################################################

pwlibs: bindir libs mods libks_solvers dftd3
	if test -d PW ; then \
	( cd PW ; $(MAKE) pw-lib || exit 1) ; fi

phlibs: pwlibs lrmods
	if test -d PHonon; then \
	( cd PHonon; $(MAKE) ph-lib || exit 1) ; fi

hplibs: pwlibs lrmods
	if test -d HP; then \
	( cd HP; $(MAKE) hp-lib || exit 1) ; fi

gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) gwwa || exit 1 ) ; fi

pw4gwwlib : phlibs
	if test -d GWW ; then \
	( cd GWW ; $(MAKE) pw4gwwa || exit 1 ) ; fi

mods : libfox libutil libla libfft libupf libbeef
	( cd Modules ; $(MAKE) TLDEPS= all || exit 1 )

libks_solvers : libs libutil libla
	( cd KS_Solvers ; $(MAKE) TLDEPS= all || exit 1 )

libla : liblapack libutil libcuda
	( cd LAXlib ; $(MAKE) TLDEPS= all || exit 1 )

libfft : 
	( cd FFTXlib ; $(MAKE) TLDEPS= all || exit 1 )

libutil : 
	( cd UtilXlib ; $(MAKE) TLDEPS= all || exit 1 )

libupf : libfox libutil
	( cd upflib ; $(MAKE) TLDEPS= all || exit 1 )

libs :
	( cd clib ; $(MAKE) TLDEPS= all || exit 1 )

lrmods : mods pwlibs
	( cd LR_Modules ; $(MAKE) TLDEPS= all || exit 1 )

dftd3 : mods
	( cd dft-d3 ; $(MAKE) TLDEPS= all || exit 1 )

bindir :
	test -d bin || mkdir bin

#############################################################
# Targets for external libraries
############################################################

liblapack: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libfox: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libcuda: 
	cd install ; $(MAKE) -f extlibs_makefile $@

libbeef:
	cd install ; $(MAKE) -f extlibs_makefile $@

#########################################################
# plugins
#########################################################

w90: bindir liblapack
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

want: liblapack
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

yambo: liblapack
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

#########################################################
# "make links" produces links to all executables in bin/
#########################################################

# Contains workaround for name conflicts (dos.x and bands.x) with WANT
links : bindir
	( cd bin/ ; \
	rm -f *.x ; \
	for exe in ../*/*/*.x ../*/bin/* ; do \
	    if test ! -L $$exe ; then ln -fs $$exe . ; fi \
	done ; \
	[ -f ../WANT/wannier/dos.x ] && \
		ln -fs ../WANT/wannier/dos.x ../bin/dos_want.x ; \
	[ -f ../PP/src/dos.x ] &&  \
		ln -fs ../PP/src/dos.x ../bin/dos.x ; \
	[ -f ../WANT/wannier/bands.x ] && \
		ln -fs ../WANT/wannier/bands.x ../bin/bands_want.x ; \
	[ -f ../PP/src/dos.x ] &&  ln -fs ../PP/src/bands.x ../bin/bands.x ; \
	[ -f ../W90/wannier90.x ] &&  ln -fs ../W90/wannier90.x ../bin/wannier90.x ;\
	)

#############################################################
# 'make install' works with "configure --prefix=PREFIX"
# - If the PREFIX/bin directory does not exists it creates it
#############################################################

install : 
	mkdir -p $(PREFIX)/bin ; \
	for x in `find * ! -path "test-suite/*" -name *.x -type f` ; do \
		cp -v $$x $(PREFIX)/bin/ ; done
	@echo -e '\nQuantum ESPRESSO binaries are installed in $(PREFIX)/bin\n'

#########################################################
# Other targets: clean up
#########################################################

# remove object files and executables
clean : 
	touch make.inc 
	for dir in \
		CPV LAXlib FFTXlib UtilXlib upflib Modules PP PW EPW KS_Solvers \
		NEB ACFDT COUPLE GWW XSpectra PWCOND dft-d3 \
		atomic clib LR_Modules pwtools upflib \
		dev-tools extlibs Environ TDDFPT PHonon HP GWW Doc GUI \
	; do \
	    if test -d $$dir ; then \
		( cd $$dir ; \
		$(MAKE) TLDEPS= clean ) \
	    fi \
	done
	- @(cd install ; $(MAKE) -f plugins_makefile clean)
	- @(cd install ; $(MAKE) -f extlibs_makefile clean)
	- /bin/rm -rf bin/*.x tempdir

# remove files produced by "configure" as well
veryclean : clean
	- @(cd install ; $(MAKE) -f plugins_makefile veryclean)
	- @(cd install ; $(MAKE) -f extlibs_makefile veryclean)
	- (cd install ; rm -rf config.log configure.msg config.status \
		configure.h make_wannier90.inc autom4te.cache )
	- (cd include; rm -rf configure.in qe_cdefs.h )
	- rm -f espresso.tar.gz
	- rm -rf make.inc
	- rm -rf FoX
# remove everything not in the original distribution
distclean : veryclean
	- cd pseudo; ./clean_ps ; cd -
	( cd install ; $(MAKE) -f plugins_makefile $@ || exit 1 )

tar :
	@if test -f espresso.tar.gz ; then /bin/rm espresso.tar.gz ; fi
	# do not include unneeded stuff 
	find ./ -type f | grep -v -e /.svn/ -e'/\.' -e'\.o$$' -e'\.mod$$'\
		-e /.git/ -e'\.a$$' -e'\.d$$' -e'\.i$$' -e'_tmp\.f90$$' -e'\.x$$' \
		-e'~$$' -e'\./GUI' -e '\./tempdir' | xargs tar rvf espresso.tar
	gzip espresso.tar

#########################################################
# Tools for the developers
#########################################################
tar-gui :
	@if test -d GUI/PWgui ; then \
	    cd GUI/PWgui ; \
	    $(MAKE) TLDEPS= clean init pwgui-source; \
	    mv PWgui-*.tgz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-gui works only for git sources !!!" ; \
	    echo ; \
	fi

tar-qe-modes :
	@if test -d GUI/QE-modes ; then \
	    cd GUI/QE-modes ; \
	    $(MAKE) TLDEPS= veryclean tar; \
	    mv QE-modes-*.tar.gz ../.. ; \
	else \
	    echo ; \
	    echo "  Sorry, tar-qe-modes works only for git sources !!!" ; \
	    echo ; \
	fi

# NOTICE about "make doc": in order to build the .html and .txt
# documentation in Doc, "tcl", "tcllib", "xsltproc" are needed;
# in order to build the .pdf files in Doc, "pdflatex" is needed;
# in order to build html files for the user guide,
# "latex2html" and "convert" (from Image-Magick) are needed.
doc : 
	if test -d Doc ; then \
	( cd Doc ; $(MAKE) VERSION=6.6 TLDEPS= all ) ; fi
	for dir in */Doc; do \
	( if test -f $$dir/Makefile ; then \
	( cd $$dir; $(MAKE) VERSION=6.6 TLDEPS= all ) ; fi ) ;  done

doc_clean :
	if test -d Doc ; then \
	( cd Doc ; $(MAKE) TLDEPS= clean ) ; fi
	for dir in */Doc; do \
	( if test -f $$dir/Makefile ; then \
	( cd $$dir; $(MAKE) TLDEPS= clean ) ; fi ) ;  done

depend:
	@echo 'Checking dependencies...'
	- ( if test -x install/makedeps.sh ; then install/makedeps.sh ; fi)

=== ACEMD/Makefile ===
CPPFLAGS=-I./ 
SRC=*.c
OUT=plumed.so

default: $(OUT)

links:
	ln -s -f ../common_files/* .

$(OUT): links
	gcc  $(CPPFLAGS) -O3 -DACEMD -fPIC --shared -o $(OUT) *.c

clean:
	rm -f $(OUT) 
	find -type l -delete
	find -name \*~ -delete

veryclean: clean
	rm *~ TAGS

=== COUPLE/CMakeLists.txt ===
set(sources
    src/libpwscf.f90
    src/libcpv.f90
    src/libqemod.f90)

qe_add_library(qe_couple ${sources})
add_library(QE::COUPLE ALIAS qe_couple)
target_link_libraries(qe_couple
    PRIVATE
        QE::Modules
        QE::LAX
	    QE::FFTX
        QE::UTILX
        QE::CPV)

###########################################################

qe_install_targets(qe_couple)

=== CPV/CMakeLists.txt ===
set(sources
    src/berryion.f90
    src/bforceion.f90
    src/cell_nose.f90
    src/cg.f90
    src/cg_sub.f90
    src/cglib.f90
    src/chargedensity.f90
    src/cp_autopilot.f90
    src/cp_emass.f90
    src/cp_interfaces.f90
    src/cp_restart_new.f90
    src/cplib.f90
    src/cpr_mod.f90
    src/cpr.f90
    src/dealloc.f90
    src/dforceb.f90
    src/efermi.f90
    src/efield.f90
    src/eigs0.f90
    src/electrons.f90
    src/electrons_nose.f90
    src/energies.f90
    src/ensemble_dft.f90
    src/exch_corr.f90
    src/exx_cg.f90
    src/exx_es.f90
    src/exx_gs.f90
    src/exx_module.f90
    src/exx_pair.f90
    src/exx_psi.f90
    src/exx_vofr.f90
    src/forces.f90
    src/fromscra.f90
    src/gram.f90
    src/gtable.f90
    src/init.f90
    src/init_run.f90
    src/inner_loop_cold.f90
    src/input.f90
    src/ions_nose.f90
    src/ions_positions.f90
    src/ksstates.f90
    src/ldaU_cp.f90
    src/ldaU.f90
    src/ldaUpen.f90
    src/mainvar.f90
    src/cpr_loop.f90
    src/cplib_meta.f90
    src/metaxc.f90
    src/modules.f90
    src/move_electrons.f90
    src/newd.f90
    src/nl_base.f90
    src/nlcc.f90
    src/ortho_base.f90
    src/ortho.f90
    src/phasefactor.f90
    src/plugin_add_potential.f90
    src/plugin_clean.f90
    src/plugin_clock.f90
    src/plugin_energy.f90
    src/plugin_ext_forces.f90
    src/plugin_get_potential.f90
    src/plugin_init_base.f90
    src/plugin_init_cell.f90
    src/plugin_initialization.f90
    src/plugin_init_ions.f90
    src/plugin_int_forces.f90
    src/plugin_print_energies.f90
    src/plugin_print_info.f90
    src/plugin_read_input.f90
    src/plugin_utilities.f90
    src/potentials.f90
    src/pres_ai_mod.f90
    src/print_out.f90
    src/printout_base.f90
    src/problem_size.f90
    src/pseudo_base.f90
    src/pseudopot.f90
    src/pseudopot_sub.f90
    src/qmatrixd.f90
    src/qqberry.f90
    src/restart.f90
    src/restart_sub.f90
    src/runcp.f90
    src/sic.f90
    src/smallbox.f90
    src/smallbox_grid.f90
    src/smallbox_gvec.f90
    src/smallbox_subs.f90
    src/smallbox_lib.f90
    src/spline.f90
    src/spinsq.f90
    src/stop_run.f90
    src/stress.f90
    src/vol_clu.f90
    src/vofrho.f90
    src/wannier_base.f90
    src/wannier.f90
    src/wave.f90
    src/wave_types.f90
    src/wf.f90
    src/makov_payne.f90
    src/entropy.f90)

qe_add_library(qe_cpv ${sources})
add_library(QE::CPV ALIAS qe_cpv)
target_link_libraries(qe_cpv
    PRIVATE
        QE::LAX
        QE::UTILX
        QE::Modules
        QE::FOX
        QE::FFTX
        QE::UPF
        QE::OpenMP_Fortran
        QE::MPI_Fortran)

###########################################################
# cp.x
###########################################################
set(sources src/cprstart.f90)
qe_add_executable(qe_cpv_exe ${sources})
set_target_properties(qe_cpv_exe PROPERTIES OUTPUT_NAME cp.x)
target_link_libraries(qe_cpv_exe
    PRIVATE
        QE::Modules
        QE::LAX
        QE::CPV
        QE::UTILX)

###########################################################
# manycp.x
###########################################################
set(sources src/manycp.f90)
qe_add_executable(qe_cpv_manycp_exe ${sources})
set_target_properties(qe_cpv_manycp_exe PROPERTIES OUTPUT_NAME manycp.x)
target_link_libraries(qe_cpv_manycp_exe
    PRIVATE
        QE::LAX
        QE::Modules
        QE::UTILX
        QE::CPV)

###########################################################
# cppp.x
###########################################################
set(sources src/cppp.f90)
qe_add_executable(qe_cpv_cppp_exe ${sources})
set_target_properties(qe_cpv_cppp_exe PROPERTIES OUTPUT_NAME cppp.x)
target_link_libraries(qe_cpv_cppp_exe
    PRIVATE
        QE::Modules
        QE::CPV
        QE::CLIB
        QE::UTILX)

###########################################################
# wfdd.x
###########################################################
set(sources src/wfdd.f90)
qe_add_executable(qe_cpv_wfdd_exe ${sources})
set_target_properties(qe_cpv_wfdd_exe PROPERTIES OUTPUT_NAME wfdd.x)
target_link_libraries(qe_cpv_wfdd_exe
    PRIVATE
        QE::LAPACK
        QE::Modules
        QE::CPV)

###########################################################

qe_install_targets(
    # Libraries
    qe_cpv
    # Exacutables
    qe_cpv_exe
    qe_cpv_manycp_exe
    qe_cpv_cppp_exe
    qe_cpv_wfdd_exe)

=== Doc/CMakeLists.txt ===
include(UseLATEX)

# By default the manuals are generated and installed in pdf format
# To generat the manuals use the following command: make pdf

# It is possible to generate user_guide and developer_man 
# in HTML format with the following command: make html

set(LATEX_DEFAULT_BUILD "pdf")

add_latex_document(
    user_guide.tex
    INPUTS quote.tex html.sty
    IMAGES quantum_espresso.pdf)

add_latex_document(
    developer_man.tex 
    INPUTS html.sty
    IMAGES quantum_espresso.pdf)

add_latex_document(
    constraints_HOWTO.tex
    FORCE_PDF)

add_latex_document(
    brillouin_zones.tex
    IMAGE_DIRS images
    FORCE_PDF)

add_latex_document(
    plumed_quick_ref.tex
    IMAGE_DIRS pic
    FORCE_PDF)

install(
    FILES
        ${PROJECT_BINARY_DIR}/Doc/user_guide.pdf 
        ${PROJECT_BINARY_DIR}/Doc/developer_man.pdf
        ${PROJECT_BINARY_DIR}/Doc/constraints_HOWTO.pdf
        ${PROJECT_BINARY_DIR}/Doc/brillouin_zones.pdf
        ${PROJECT_BINARY_DIR}/Doc/plumed_quick_ref.pdf
    DESTINATION 
        share/qe)

=== Doc/Makefile ===
LATEX   = pdflatex
LATEX2HTML = latex2html

PDFS = constraints_HOWTO.pdf  user_guide.pdf brillouin_zones.pdf
AUXS = $(PDFS:.pdf=.aux)
LOGS = $(PDFS:.pdf=.log)
OUTS = $(PDFS:.pdf=.out)
TOCS = $(PDFS:.pdf=.toc)

all:  pdf html
pdf:  $(PDFS)
html: user_guide

$(PDFS): %.pdf: %.tex
	$(LATEX)  $<
	$(LATEX)  $<

clean:
	- rm -f $(PDFS) $(AUXS) $(LOGS) $(OUTS) $(TOCS) *~
	- rm -rf user_guide/ 
	- rm -f INPUT_*.html INPUT_*.txt INPUT_*.xml qe-input-ref.html

user_guide: user_guide.pdf
	 - rm -rf user_guide/
	 - latex2html \
                -t "User's Guide for Quantum-ESPRESSO" \
                -html_version 3.2,math \
                -toc_depth 5 -split 5 -toc_stars -show_section_numbers \
                -local_icons -image_type png \
                user_guide.tex
	if test -d user_guide; then \
		cd user_guide; \
	        for file in *.html; do \
	                cp $$file /tmp/$$file; \
	                cat /tmp/$$file | sed 's/HREF="http/NAME="http/g' | sed 's/mathend000#//g' - > $$file; \
	                rm -f /tmp/$$file; \
	        done; \
	fi
	@if test -d user_guide; then \
		echo ""; \
		echo "***"; \
		echo "*** User's Guide created in user_guide/user_guide.html"; \
		echo "***"; \
		echo ""; \
	fi

brillouin_zones: brillouin_zones.pdf

=== EPW/CMakeLists.txt ===
set(sources
    src/epwcom.f90
    src/constants_epw.f90
    src/elph2.f90
    src/io_var.f90
    src/low_lvl.f90
    src/division.f90
    src/rigid_epw.f90
    src/io_epw.f90
    src/io_transport.f90
    src/io_selfen.f90
    src/wigner.f90
    src/wan2bloch.f90
    src/cum_mod.f90
    src/close_epw.f90
    src/poolgathering.f90
    src/printing.f90
    src/kfold.f90
    src/dynmat_asr.f90
    src/io_eliashberg.f90
    src/utilities.f90
    src/eliashbergcom.f90
    src/supercond.f90
    src/supercond_iso.f90
    src/supercond_aniso.f90
    src/grid.f90
    src/rotate.f90
    src/transport.f90
    src/transport_iter.f90
    src/pw2wan2epw.f90
    src/wannierization.f90
    src/indabs.f90
    src/bcast_epw_input.f90
    src/bloch2wan.f90
    src/dvqpsi.f90
    src/eliashberg.f90
    src/elphel2_shuffle.f90
    src/elphon_shuffle.f90
    src/elphon_shuffle_wrap.f90
    src/selfen.f90
    src/spectral_func.f90
    src/ephwann_shuffle.f90
    src/ephwann_shuffle_mem.f90
    src/epw_init.f90
    src/epw_readin.f90
    src/epw_setup.f90
    src/epw_summary.f90
    src/loadumat.f90
    src/stop_epw.f90
    src/wannierEPW.f90
    src/loadbm.f90
    src/ephblochkq.f90
    src/wfc_elec.f90
    src/test_tools.f90)

qe_add_library(qe_epw ${sources})
add_library(QE::EPW ALIAS qe_epw)
target_link_libraries(qe_epw
    PRIVATE
        QE::WANNIER90
        QE::Modules
        QE::LR_Modules
        QE::PHonon::PH
        QE::PW
        QE::MPI_Fortran
        QE::UTILX
        QE::UPF
        QE::FFTX)

###########################################################
# epw.x
###########################################################
set(sources src/epw.f90)
qe_add_executable(qe_epw_exe ${sources})
set_target_properties(qe_epw_exe PROPERTIES OUTPUT_NAME epw.x)
target_link_libraries(qe_epw_exe
    PRIVATE
        QE::Modules
        QE::PP
	    QE::PW
	    QE::FFTX
        QE::UTILX
        QE::EPW)

###########################################################

qe_install_targets(
    # Libraries
    qe_epw
    # Exacutables
    qe_epw_exe)

=== FFTXlib/CMakeLists.txt ===
###########################################################
# FFT
# The following targets will be defined:
add_library(qe_fft INTERFACE)
add_library(QE::FFT ALIAS qe_fft)
qe_install_targets(qe_fft)
###########################################################
SET(BLA_VENDOR_SAVED ${BLA_VENDOR})
if(QE_FFTW_VENDOR STREQUAL "AUTO")
    # Try to find a FFTW library installed in the system
    find_package(VendorFFTW)
    if(VendorFFTW_FOUND)
        if(VendorFFTW_ID STREQUAL "Intel")
            qe_add_global_compile_definitions(__DFTI)
            set(qe_fft_wrappers fft_scalar.DFTI.f90)
        elseif(VendorFFTW_ID STREQUAL "Arm")
            ## ARMPL implements the same interface of the standard FFTW
            ## no need of QE ARMPL wrapper
            #qe_add_global_compile_definitions(__ARM_LIB)
            #set(qe_fft_wrappers fft_scalar.ARM_LIB.f90)
            qe_add_global_compile_definitions(__FFTW3)
            set(qe_fft_wrappers fft_scalar.FFTW3.f90)
        elseif(VendorFFTW_ID STREQUAL "IBMESSL")
            qe_add_global_compile_definitions(__LINUX_ESSL)
            set(qe_fft_wrappers fft_scalar.ESSL.f90)
        endif()
        target_link_libraries(qe_fft INTERFACE VendorFFTW)
    else()
        # Try to find the official FFTW3
        message(STATUS "No vendor FFTW found")
        if(QE_ENABLE_OPENMP)
            find_package(FFTW3 COMPONENTS DOUBLE_OPENMP DOUBLE)
        else()
            find_package(FFTW3 COMPONENTS DOUBLE)
        endif()
        if(FFTW3_FOUND)
            qe_add_global_compile_definitions(__FFTW3)
            set(qe_fft_wrappers fft_scalar.FFTW3.f90)
            target_link_libraries(qe_fft INTERFACE FFTW3)
        else()
            message(STATUS "CMake variable FFTW3_ROOT may be used to hint the root directory of FFTW3 installation.")
            # Cannot find anything useful, just point out internal FFTW fallback.
            message(FATAL_ERROR "Failed to find an external FFTW library. "
                                "Alternatively, '-DQE_FFTW_VENDOR=Internal' may be used to enable reference FFTW "
                                "at a performance loss compared to optimized libraries.")

        endif()
    endif()
elseif(QE_FFTW_VENDOR MATCHES "Intel")
    if(QE_FFTW_VENDOR STREQUAL "Intel_DFTI")
        qe_add_global_compile_definitions(__DFTI)
        set(qe_fft_wrappers fft_scalar.DFTI.f90)
    elseif(QE_FFTW_VENDOR STREQUAL "Intel_FFTW3")
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_fft_wrappers fft_scalar.FFTW3.f90)
    else()
        message(FATAL_ERROR "The unknown Intel FFTW library '${QE_FFTW_VENDOR}' is not supported!")
    endif()
    if(QE_ENABLE_OPENMP)
        SET(BLA_VENDOR Intel10_64lp)
    else()
        SET(BLA_VENDOR Intel10_64lp_seq)
    endif()
    find_package(LAPACK QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS MKL)
    if(VendorFFTW_FOUND)
        target_link_libraries(qe_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "ArmPL")
    if(QE_ENABLE_OPENMP)
        SET(BLA_VENDOR Arm_mp)
    else()
        SET(BLA_VENDOR Arm)
    endif()
    find_package(LAPACK QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS ArmPL)
    if(VendorFFTW_FOUND)
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_fft_wrappers fft_scalar.FFTW3.f90)
        target_link_libraries(qe_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "IBMESSL")
    SET(BLA_VENDOR IBMESSL)
    find_package(BLAS QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS IBMESSL)
    if(VendorFFTW_FOUND)
        qe_add_global_compile_definitions(__LINUX_ESSL)
        set(qe_fft_wrappers fft_scalar.ESSL.f90)
        target_link_libraries(qe_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "FFTW3")
    if(QE_ENABLE_OPENMP)
        find_package(FFTW3 REQUIRED COMPONENTS DOUBLE_OPENMP DOUBLE)
    else()
        find_package(FFTW3 REQUIRED COMPONENTS DOUBLE)
    endif()
    if(FFTW3_FOUND)
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_fft_wrappers fft_scalar.FFTW3.f90)
        target_link_libraries(qe_fft INTERFACE FFTW)
        message(STATUS "Found FFTW3 library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "Internal")
    message(STATUS "QE internal implementation of FFTW (FFTXLib)")
    qe_add_global_compile_definitions(__FFTW)
    set(qe_fft_wrappers fft_scalar.FFTW.f90)
else()
    message(FATAL_ERROR "The FFTW vendor library '${QE_FFTW_VENDOR}' is not supported!")
endif()
SET(BLA_VENDOR ${BLA_VENDOR_SAVED})

set(f_sources
    fft_scatter.f90
    fft_scatter_2d.f90
    scatter_mod.f90 
    fft_ggen.f90
    fft_fwinv.f90
    fft_scalar.f90
    fftw_interfaces.f90
    fft_parallel.f90
    fft_parallel_2d.f90
    fft_interfaces.f90
    fft_interpolate.f90
    stick_base.f90
    fft_smallbox.f90
    fft_smallbox_type.f90
    fft_support.f90
    fft_error.f90
    fft_types.f90
    tg_gather.f90
    fft_helper_subroutines.f90
    fft_param.f90)

if(QE_ENABLE_CUDA)
  set(f_sources ${f_sources}
      fft_scatter_gpu.f90
      fft_scatter_2d_gpu.f90
      fft_buffers.f90
      fft_scalar.cuFFT.f90)
endif()

set(c_sources
    fft_stick.c
    fftw.c
    fftw_sp.c
    fftw_dp.c)

qe_add_library(qe_fftx ${f_sources} ${c_sources} ${qe_fft_wrappers})
add_library(QE::FFTX ALIAS qe_fftx)
target_link_libraries(qe_fftx
    PRIVATE
        QE::FFT
        QE::OpenMP_Fortran
        QE::MPI_Fortran
        QE::LAPACK)
qe_install_targets(qe_fftx)

###########################################################
# Tests
# TODO move all tests to a proper location
###########################################################
if(QE_ENABLE_TEST)
    set(sources fft_test.f90)
    qe_add_executable(qe_fftx_test ${sources})
    set_target_properties(qe_fftx_test PROPERTIES OUTPUT_NAME qe_fftx_test.x RUNTIME_OUTPUT_DIRECTORY ${QE_TESTS_DIR})
    target_link_libraries(qe_fftx_test
        PRIVATE
            QE::OpenMP_Fortran
            QE::MPI_Fortran
            QE::LAPACK
            QE::FFTX)
    add_test(NAME test_qe_fftx COMMAND ${QE_TESTS_DIR}/qe_fftx_test.x)
endif()

=== FFTXlib/Makefile ===
# Makefile for FFTXlib

include ../make.inc

FFTX = \
scatter_mod.o  \
fft_scatter_2d.o  \
fft_scatter_gpu.o  \
fft_scatter_2d_gpu.o  \
fft_ggen.o  \
fft_fwinv.o  \
fft_scalar.o  \
fft_scalar.ARM_LIB.o  \
fft_scalar.DFTI.o  \
fft_scalar.ESSL.o  \
fft_scalar.FFTW.o  \
fft_scatter.o  \
fft_scalar.cuFFT.o  \
fftw_interfaces.o  \
fft_scalar.FFTW3.o  \
fft_scalar.SX6.o  \
fft_parallel.o  \
fft_parallel_2d.o  \
fft_interfaces.o  \
fft_interpolate.o \
stick_base.o  \
fftw.o  \
fftw_sp.o  \
fftw_dp.o  \
fft_smallbox.o  \
fft_smallbox_type.o  \
fft_support.o  \
fft_error.o  \
fft_stick.o  \
fft_types.o \
tg_gather.o \
fft_helper_subroutines.o \
fft_param.o \
fft_buffers.o 


all : libqefft.a

libqefft.a: 	$(FFTX)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

fft_scalar.o : fft_scalar.f90  fft_scalar.FFTW3.f90  fft_scalar.FFTW.f90  fft_scalar.SX6.f90 fft_scalar.DFTI.f90  fft_scalar.ESSL.f90


fft_stick.o : fft_stick.c fftw_sp.h fftw_dp.h

fftw.o : fftw.c fftw.h

fftw_sp.o : fftw_sp.c fftw_sp.h fftw.h konst.h

fftw_dp.o : fftw_dp.c fftw_dp.h fftw.h konst.h

test : fft_test.o libqefft.a
	$(LD) $(LDFLAGS) -o fft_test.x fft_test.o libqefft.a $(FFT_LIBS) $(BLAS_LIBS) $(MPI_LIBS) $(LD_LIBS)

TEST : test # compatibility

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L 

include make.depend

=== GUI/Makefile ===
# makefile for pwgui
sinclude ../make.inc
# do nothing by default !!!
default:

clean:
	- if test -d PWgui ; then ( cd PWgui; $(MAKE) clean ) ; fi
	- if test -d QE-modes ; then ( cd QE-modes; $(MAKE) clean ) ; fi

veryclean:
	- if test -d Guib ; then ( cd Guib; $(MAKE) veryclean ) ; fi
	- if test -d PWgui ; then ( cd PWgui; $(MAKE) distclean ) ; fi
	- if test -d QE-modes ; then ( cd QE-modes; $(MAKE) veryclean ) ; fi

distclean: veryclean

=== GWW/CMakeLists.txt ===
set(sources_gww
    gww/basic_structures.f90
    gww/compact_product.f90
    gww/contour.f90
    gww/create_hf.f90
    gww/create_quasi_particle.f90
    gww/create_quasi_particle_off.f90
    gww/do_contour.f90
    gww/do_polarization_lanczos.f90
    gww/do_self_lanczos.f90
    gww/do_self_lanczos_time.f90
    gww/do_self_lanczos_full.f90
    gww/energies_gww.f90
    gww/expansion.f90
    gww/fft_gw.f90
    gww/fit_multipole.f90
    gww/fit_polynomial.f90
    gww/go_dressed_w.f90
    gww/go_exchange.f90
    gww/go_fft.f90
    gww/go_green.f90
    gww/go_polarization.f90
    gww/green_function.f90
    gww/gv_time.f90
    gww/input_gw.f90
    gww/lanczos_polarization.f90
    gww/para_gww.f90
    gww/polarization.f90
    gww/read_data_pw.f90
    gww/self_energy.f90
    gww/self_energy_storage.f90
    gww/start_end.f90
    gww/times_gw.f90
    gww/vcprim.f90)

set(sources_pw4gww
    pw4gww/allocate_wannier.f90
    pw4gww/produce_wannier_gamma.f90
    pw4gww/start_pw4gww.f90
    pw4gww/stop_pp.f90
    pw4gww/openfil_pw4gww.f90
    pw4gww/dft_exchange.f90
    pw4gww/wfc_real.f90
    pw4gww/full.f90
    pw4gww/energies_xc.f90
    pw4gww/wannier.f90
    pw4gww/write_wannier_matrix.f90
    pw4gww/rotate_wannier.f90
    pw4gww/self_lanczos.f90
    pw4gww/pola_lanczos.f90
    pw4gww/matrix_wannier_gamma.f90
    pw4gww/calculate_wing.f90
    pw4gww/fake_conduction.f90
    pw4gww/o_1psi.f90
    pw4gww/o_bands.f90
    pw4gww/optimal.f90
    pw4gww/pola_partial.f90
    pw4gww/semicore.f90
    pw4gww/semicore_read.f90
    pw4gww/v_basis.f90
    pw4gww/wannier_uterms.f90
    pw4gww/write_vpot_matrix.f90
    pw4gww/diago_cg.f90
    pw4gww/o_rinitcgg.f90
    pw4gww/diago_cg_g.f90
    pw4gww/contour_terms.f90
    pw4gww/fft_custom.f90
    pw4gww/exchange_custom.f90
    pw4gww/mp_wave_parallel.f90
    pw4gww/wannier_bse.f90
    pw4gww/hpsi_pw4gww.f90
    pw4gww/cgsolve_all_gamma.f90
    pw4gww/realus.f90)

set(sources_bse
    bse/openfil_bse.f90
    bse/start_bse.f90
    bse/bse_wannier.f90
    bse/transitions.f90
    bse/read_export.f90
    bse/bse_basic_structure.f90
    bse/exciton.f90
    bse/diago_exc.f90
    bse/exchange_exc.f90
    bse/rotate_wannier.f90
    bse/write_wannier_matrix.f90
    bse/direct_v_exc.f90
    bse/direct_w_exc.f90
    bse/exc_h_a.f90
    bse/sdescent.f90
    bse/check_basis.f90
    bse/conjgrad.f90
    bse/conj_grad_stuff.f90
    bse/find_eig.f90
    bse/plot_excwfn.f90
    bse/tspace.f90
    bse/absorption.f90
    bse/spectrum.f90
    bse/absorption.f90
    bse/cgsolve.f90
    bse/h_h.f90
    bse/dvpsi_bse.f90
    bse/lanczos.f90
    bse/print_spectrum.f90
    bse/print_bse.f90
    bse/contract_w_exc.f90
    bse/qpe_exc.f90
    bse/qpcorrections.f90)

set(sources_head
    head/bcast_ph_input.f90
    head/close_phq.f90
    head/lanczos_k.f90
    head/openfilq.f90
    head/phq_readin.f90
    head/solve_head.f90)

set(sources_minpack
    minpack/dpmpar.f90
    minpack/fdjac2.f90
    minpack/lmder1.f90
    minpack/lmdif1.f90
    minpack/mlagzo.f90
    minpack/qrfac.f90
    minpack/test.f90
    minpack/enorm.f90
    minpack/lmder.f90
    minpack/lmdif.f90
    minpack/lmpar.f90
    minpack/mlegzo.f90
    minpack/qrsolv.f90)

set(sources_simple
    simple/stop_pp.f90
    simple/read_export.f90
    simple/openfile_simple.f90
    simple/input_simple.f90
    simple/wfc_basis.f90
    simple/product_basis.f90
    simple/v_product.f90
    simple/epe.f90
    simple/gk_sort_limit.f90
    simple/khamiltonian.f90
    simple/init_us_2_max.f90
    simple/commutator.f90)

set(sources_simple_bse
    simple_bse/simple_object.f90
    simple_bse/start_end.f90
    simple_bse/input_simple_exc.f90
    simple_bse/simple_eigen.f90
    simple_bse/diago_exc_sd.f90
    simple_bse/hamiltonian.f90
    simple_bse/derived_object.f90
    simple_bse/diago_exc_cg.f90
    simple_bse/spectrum.f90
    simple_bse/lanczos.f90
    simple_bse/build_eemat.f90)

set(sources_simple_ip
    simple_ip/simple_ip_objects.f90
    simple_ip/start_end.f90
    simple_ip/input_simple_ip.f90
    simple_ip/tetra_mod1.f90
    simple_ip/interpolation.f90
    simple_ip/diagonalization.f90
    simple_ip/dielectric.f90)

qe_add_library(qe_gww ${sources_gww})
add_library(QE::GWW ALIAS qe_gww)
target_link_libraries(qe_gww
    PRIVATE
        QE::FFTX
        QE::UTILX
        QE::Modules)

qe_add_library(qe_gww_pw4gww ${sources_pw4gww})
add_library(QE::GWW::pw4gww ALIAS qe_gww_pw4gww)
target_link_libraries(qe_gww_pw4gww
    PRIVATE
        QE::SCALAPACK
        QE::PW
        QE::Modules
        QE::GWW
        QE::UTILX
        QE::FFTX
        QE::UPF
        QE::LAX)

qe_add_library(qe_gww_bse ${sources_bse})
add_library(QE::GWW::bse ALIAS qe_gww_bse)
target_link_libraries(qe_gww_bse
    PRIVATE
        QE::PW
        QE::Modules
        QE::GWW
        QE::GWW::pw4gww
        QE::UTILX
        QE::UPF)

qe_add_library(qe_gww_head ${sources_head})
add_library(QE::GWW::head ALIAS qe_gww_head)
target_link_libraries(qe_gww_head
    PRIVATE
        QE::PW
        QE::LR_Modules
        QE::Modules
        QE::PHonon::PH
        QE::UTILX
        QE::UPF
        QE::FFTX)

qe_add_library(qe_gww_minpack ${sources_minpack})
add_library(QE::GWW::minpack ALIAS qe_gww_minpack)
target_link_libraries(qe_gww_minpack
    PRIVATE
        QE::Modules)

qe_add_library(qe_gww_simple ${sources_simple})
add_library(QE::GWW::simple ALIAS qe_gww_simple)
target_link_libraries(qe_gww_simple
    PRIVATE
        QE::PW
        QE::GWW
        QE::Modules
        QE::UPF
        QE::UTILX
        QE::FFTX)

qe_add_library(qe_gww_simplebse ${sources_simple_bse})
add_library(QE::GWW::simple_bse ALIAS qe_gww_simplebse)
target_link_libraries(qe_gww_simplebse
    PRIVATE
        QE::UTILX
        QE::Modules)

qe_add_library(qe_gww_simpleip ${sources_simple_ip})
add_library(QE::GWW::simple_ip ALIAS qe_gww_simpleip)
target_link_libraries(qe_gww_simpleip
    PRIVATE
        QE::UTILX
        QE::Modules)

###########################################################
# graph.x
###########################################################
set(sources util/graph.f90)
qe_add_executable(qe_gww_util_grap_exe ${sources})
set_target_properties(qe_gww_util_grap_exe PROPERTIES OUTPUT_NAME graph.x)

###########################################################
# abcoeff_to_eps.x
###########################################################
set(sources util/abcoeff_to_eps.f90)
qe_add_executable(qe_gww_util_abcoefftoeps_exe ${sources})
set_target_properties(qe_gww_util_abcoefftoeps_exe PROPERTIES OUTPUT_NAME abcoeff_to_eps.x)

###########################################################
# memory_pw4gww.x
###########################################################
set(sources util/memory_pw4gww.f90)
qe_add_executable(qe_gww_util_memorypw4gww_exe ${sources})
set_target_properties(qe_gww_util_memorypw4gww_exe PROPERTIES OUTPUT_NAME memory_pw4gww.x)

###########################################################

qe_install_targets(
    # Libraries
    qe_gww
    qe_gww_pw4gww
    qe_gww_bse
    qe_gww_head
    qe_gww_minpack
    qe_gww_simple
    qe_gww_simplebse
    qe_gww_simpleip
    # Executables
    qe_gww_util_grap_exe
    qe_gww_util_abcoefftoeps_exe
    qe_gww_util_memorypw4gww_exe)

=== debian/changelog ===
espresso (6.7-4) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    Closes: #1096588.

  [ Santiago Vila ]
  * Use standard simplified salsa-ci.yml.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Sun, 05 Oct 2025 18:20:00 +0200

espresso (6.7-3) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository-Browse.
  * debian/watch: Use GitHub /tags rather than /releases page.
  * Update standards version to 4.2.1, no changes needed.
  * Apply multi-arch hints. + quantum-espresso-data: Add Multi-Arch: foreign.

  [ Andrius Merkys ]
  * Replace deprecated 'pipes' with 'shlex' (Closes: 1084629)

 -- Andrius Merkys <merkys@debian.org>  Wed, 09 Oct 2024 03:16:04 -0400

espresso (6.7-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * debian/rules: Fix build with dpkg exporting DFLAGS (Closes: #980677).

 -- Michael Banck <mbanck@debian.org>  Mon, 15 Feb 2021 11:25:34 +0100

espresso (6.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Switch to Github.
  * debian/patches/install_bindir.patch: Refreshed.
  * debian/patches/make-install-PHONY.patch: Likewise.
  * debian/patches/fix-911763.patch: Likewise.
  * debian/patches/system_libwannier90.patch: Likewise.
  * debian/patches/fix_example_scripts.patch: Refreshed, and updated for
    python3.
  * debian/patches/pseudopotential_dir.patch: Reimplemented without iotk.

 -- Michael Banck <mbanck@debian.org>  Wed, 06 Jan 2021 21:56:16 +0100

espresso (6.6-1) unstable; urgency=medium

  * New upstream release, new features include:
   + vdW-DF3-opt1, vdW-DF3-opt2, and vdW-DF-C6 van der Waals functionals
   + Stress for noncolinear case
   + ParO and PPCG iterative diagonalization algorithms
   + Fourier interpolation of phonon potential
   + Extension of the PW code to DFT+U+V
   + Extension of the HP code to compute also inter-site Hubbard V parameters
   + Extension of the XSpectra code to work on top of DFT+U+V
   + Extension of Hubbard forces and stress to ortho-atomic orbitals
   + Support for BEEF-vdW XC
   + Phonon-induced electron self-energy implemented in ph.x and a new
     post-processing program PHonon/postahc.x added
   + Implementation of the Sternheimer algorithm in the turboEELS code
   + EPW: Use of the band manifold determined by Wannierization step when
     evaluating electron-phonon vertex on coarse grids
   + EPW: Support for PAW
  * debian/patches/disable_pseudo_download.patch: Refreshed.
  * debian/patches/fix-911763.patch: Likewise.
  * debian/patches/install_bindir.patch: Likewise.
  * debian/patches/make-install-PHONY.patch: Likewise.
  * debian/patches/pseudopotential_dir.patch: Likewise.
  * debian/patches/configure_fix_ppc64_define.patch: Removed, no longer needed.
  * debian/patches/testsuite_python3.patch: Likewise.
  * debian/pseudo/B.pbe-n-kjpaw_psl.1.0.0.UPF,B.pbe-n-kjpaw_psl.0.1.UPF,
    B.pbe-n-rrkjus_psl.1.0.0.UPF,B.pz-vbc.UPF,
    Co.pbesol-spn-rrkjus_psl.0.3.1.UPF,Cr.pbe-spn-kjpaw_psl.1.0.0.UPF,
    Fe.pbe-spn-rrkjus_psl.0.2.1.UPF,Fe.pbesol-spn-kjpaw_psl.1.0.0.UPF,
    Fe.rel-pbe-spn-rrkjus_psl.0.2.1.UPF,I.pbe-n-kjpaw_psl.1.0.0.UPF,
    Li.pbesol-s-kjpaw_psl.0.2.1.UPF,Li.pbesol-s-rrkjus_psl.0.2.1.UPF,
    Mg.pz-n-vbc.UPF,N.pbe-n-kjpaw_psl.0.1.UPF,N.pbe-n-kjpaw_psl.1.0.0.UPF,
    N.pbe-n-rrkjus_psl.1.0.0.UPF,Ni.pbe-spn-kjpaw_psl.1.0.0.UPF,
    Ni.pbesol-n-kjpaw_psl.0.1.UPF,Ni.pbesol-n-rrkjus_psl.0.1.UPF
    O.pbesol-n-kjpaw_psl.0.1.UPF,O.pbesol-n-rrkjus_psl.0.1.UPF,
    Si.pbe-nl-rrkjus_psl.1.0.0.UPF: New files, pseudopotentials needed for new
    test cases.
  * debian/patches/system_libwannier90.patch: New patch, forces usage of the
    system-installed libwannier90.
  * debian/rules (override_dh_auto_build-arch): Also build epw target.
  * debian/rules (override_dh_auto_test): Add -k option to make in order to
    continue on failed tests.

 -- Michael Banck <mbanck@debian.org>  Mon, 04 Jan 2021 21:28:44 +0100

espresso (6.5-2) unstable; urgency=medium

  * debian/patches/testsuite_python3.patch: Updated with fix from upstream.
  * debian/control (Build-Depends): Added libwannier90-dev.
  * debian/rules (F90FLAGS): New variable, sets -fallow-argument-mismatch
    (Closes: 966950).

 -- Michael Banck <mbanck@debian.org>  Sat, 03 Oct 2020 14:05:05 +0200

=== debian/control ===
Source: espresso
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper-compat (= 13),
               gfortran,
               latex2html,
               libblas-dev,
               libfftw3-dev,
               liblapack-dev,
               libscalapack-mpi-dev,
               libwannier90-dev,
               mpi-default-dev,
               netpbm,
               python3,
               tcl,
               tcllib,
               xsltproc
Standards-Version: 4.7.2
Homepage: http://www.quantum-espresso.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/espresso
Vcs-Git: https://salsa.debian.org/debichem-team/espresso.git

Package: quantum-espresso
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: quantum-espresso-data
Description: Electronic-Structure and Ab-Initio Molecular Dynamics Suite
 Quantum ESPRESSO (formerly known as PWscf) is an integrated suite of computer
 codes for electronic-structure calculations and materials modeling at the
 nanoscale. It is based on density-functional theory, plane waves, and
 pseudopotentials (both norm-conserving, ultrasoft, and PAW).
 .
 Features include:
  * Ground-state single-point and band structure calculations using plane-wave
    self-consistent total energies, forces and stresses
  * Separable norm-conserving and ultrasoft (Vanderbilt) pseudo-potentials, PAW
    (Projector Augmented Waves)
  * Various exchange-correlation functionals, from LDA to generalized-gradient
    corrections (PW91, PBE, B88-P86, BLYP) to meta-GGA, exact exchange (HF) and
    hybrid functionals (PBE0, B3LYP, HSE)
  * Car-Parrinello and Born-Oppenheimer Molecular Dynamics
  * Structural Optimization including transition states and minimum energy
    paths
  * Spin-orbit coupling and noncollinear magnetism
  * Response properties including phonon frequencies and
    eigenvectors, effective charges and dielectric tensors, Infrared and
    Raman cross-sections, EPR and NMR chemical shifts
  * Spectroscopic properties like K- and L1-edge X-ray Absorption Spectra (XAS)
    and electronic excitations

Package: quantum-espresso-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: quantum-espresso (<< 6.3-1)
Replaces: quantum-espresso (<< 6.3-1)
Multi-Arch: foreign
Description: Electronic-Structure and Ab-Initio Molecular Dynamics Suite (Documentation)
 Quantum ESPRESSO is an integrated suite of computer codes for
 electronic-structure calculations and materials modeling at the nanoscale. It
 is based on density-functional theory, plane waves, and pseudopotentials (both
 norm-conserving, ultrasoft, and PAW).
 .
 This package contains a limited set of pseudo-potentials and example files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

export SCALAPACK_LIBS:=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export SCALAPACK_LIB:=/usr/lib
ifeq ($(DEB_BUILD_ARCH_CPU), i386)
    export FFTW_FORCE_ALIGN=-D_FFTW_FORCE_UNALIGNED
else
    export FFTW_FORCE_ALIGN=
endif
export OMPI_MCA_orte_rsh_agent=/bin/false

export F90FLAGS = $(shell dpkg-buildflags --get FFLAGS) -cpp -fallow-argument-mismatch

export DEB_CFLAGS_MAINT_APPEND = -std=gnu17

# workaround for dpkg exporting conflicting DFLAGS since #975896
export DFLAGS

%:
	dh $@

override_dh_auto_clean:
	-dh_auto_clean
	rm -rf CPV/tmp
	rm -f install/make_wannier90.sys
	rm -f install/make_lapack.inc
	rm -f install/make_blas.inc
	rm -f include/fft_defs.h
	rm -f Modules/version.f90.tmp
	rm -f include/configure.h

override_dh_auto_build-arch:
	$(MAKE) all epw

override_dh_auto_build-indep:
	$(MAKE) pw doc
	cp debian/pseudo/*.UPF pseudo/

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cp debian/pseudo/*.UPF pseudo/
	-(cd test-suite; $(MAKE) -k run-tests)
endif

override_dh_installexamples-indep:
	for DIR in $$(find . -name debian -prune -o -name .pc -prune -o -name examples -print); \
	do dh_install -p quantum-espresso-data $$DIR/* usr/share/doc/quantum-espresso/examples/$$(dirname $$DIR); \
	done

override_dh_installchangelogs:
	dh_installchangelogs Doc/release-notes

override_dh_fixperms-indep:
	dh_fixperms
	find debian/quantum-espresso-data/usr/share/doc/quantum-espresso/examples -name \*.in | xargs chmod 644

=== debian/watch ===
version=4
opts=uversionmangle=s/.-ReleasePack.*//g https://github.com/QEF/q-e/tags .*/releases/download/qe-[\d.]+/qe-([\d.]+)(-ReleasePack)?\.(tar\.(?:bz2|gz)|tgz)
